'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (req, res, next) {
  var url = decodeURIComponent(req.url);
  var splitUrl = url.split('/');
  var scope = void 0;
  var packageName = void 0;
  var requestedFile = void 0;

  if (splitUrl[2] === 'package') {
    next();
    return;
  }

  for (var i = 0; i < splitUrl.length; i++) {
    if (splitUrl[i].indexOf('@') !== -1) {
      if (scope) continue;
      scope = splitUrl[i];
      packageName = splitUrl[i + 1];
    }

    if (splitUrl[i].indexOf('-') !== -1) {
      if (i <= 1) continue;
      if (requestedFile) continue;
      if (scope) {
        requestedFile = splitUrl[i + 2];
      } else {
        requestedFile = splitUrl[i + 1];
      }
    }
  }

  if (scope && packageName) {
    req.body._scope = scope;
    req.body._packageName = packageName;
    req.body._scopedName = '/' + scope + '/' + packageName;
  } else {
    for (var _i = 0; _i < splitUrl.length; _i++) {
      if (req.body._packageName) continue;
      if (splitUrl[_i] !== '') {
        req.body._packageName = splitUrl[_i];
        if (splitUrl[_i + 1] === '-') {
          requestedFile = splitUrl[_i + 2];
        }
      }
    }
  }

  if (requestedFile) {
    req.body._requestedFile = requestedFile;
  }

  if (packageName) {
    req.url = '/' + packageName;
    if (requestedFile) {
      req.url += '/-/' + requestedFile;
    }
  }

  next();
};